; -------------------------------------
; - Reaktionszeittester mit AT90S1200 -
; - fuer Ein-Tasten-Bedienung         - 
; - Ausgabe auf 7-Segment-Anzeige     -
; - (C) 2002 Julien Thomas, Germany   -
; -------------------------------------
; V 1.0 - 9/2002 - 4 MHz 
; (siehe Anmerkungen 3.58 + 4.43 MHz!) 
; -------------------------------------
;
.include "1200def.inc" 
; verzeichnis include-datei beachten
;
.def tmp  = r16	; Universalregister 
.def rea0 = r17	; "Zufallsregister"
.def rea1 = r18	; Tausendstel Sekunden 
.def rea2 = r19	; Hundertstel Sekunden 
.def rea3 = r20	; Zehntel Sekunden

.def cnt0 = r0	; Register fuer 
.def cnt1 = r1	; Zeitschleifen 	
.def cnt2 = r2	;	
.def cnt3 = r3	;
.def ovr  = r24 ; zaehler ueberlaeufe
.def seg  = r25	; Segment-Byte
;
.cseg
; -------------------------------------
; Programmbeginn, Initialisieren 
; -------------------------------------
;
Start:
nop		;Einsprung bei RESET
cli		;Einsprung durch INT0 
ldi tmp, 32
out DDRD,tmp	;Port D alle Bits 
		;EINGABE ausser PD5 
ldi tmp,255
out DDRB,tmp	;Port B alle Bits 
		;AUSGABE
out PORTD,tmp	;Port D pullups an
;
clr ovr		;Overflow-Zaehler Null
clr cnt0
;
Stl:
ldi tmp,118	;Startmeldung "HI"	
out PORTB,tmp
rcall ddelay
ldi tmp,176
out PORTB,tmp
rcall ddelay
inc cnt0
brne Stl
;
;
; -------------------------------------
; Hauptprogramm 
; -------------------------------------
Main:
rcall ConstDelay
rcall Measure
rcall Display
rcall RandomDelay
rjmp Main
;
; -------------------------------------
; Quick'n'dirty BCD-zu-7-Segment 
; Display drei Sekunden halten 
; -------------------------------------
Display:
sbis PIND,2	;Wenn Taste gedrueckt, 
clr ovr		;Overflow-Zaehler 
ldi rea1,5	 				
clr cnt2
;
Dply:
mov tmp,rea2
rcall BCDto7Segment
ori seg,128
out portb,seg
rcall ddelay
mov tmp,rea3
rcall BCDto7Segment
out portb,seg
rcall ddelay
;
dec cnt2
brne Dply
dec rea1
brne Dply
clr tmp
out portb,tmp
ret
; 
BCDto7Segment:
ldi seg,63
cpi tmp,0 
breq Dx
ldi seg,6
cpi tmp,1
breq Dx
ldi seg,91
cpi tmp,2
breq Dx
ldi seg,79
cpi tmp,3
breq Dx
ldi seg,102
cpi tmp,4
breq Dx
ldi seg,109
cpi tmp,5
breq Dx
ldi seg,125
cpi tmp,6
breq Dx
ldi seg,7
cpi tmp,7
breq Dx
ldi seg,127
cpi tmp,8
breq Dx
ldi seg,111
cpi tmp,9
breq Dx
ldi seg,0
Dx:
ret
;
; -------------------------------------
; Signalgabe und Reaktionszeit messen
; (NOP-sei-dank recht genau!)
; -------------------------------------
Measure:
clr rea0
clr rea1
clr rea2
clr rea3
ldi tmp,255
out portb,tmp
sbis pind,2
ret
;
Mloop:
sbi PORTB,7
nop ; Schleife anpassen: 
nop ; 12 NOPs fuer 4.43 MHz
nop ; 10 NOPs fuer 4.00 MHz
nop ;  8 NOPs fuer 3.58 MHz
nop
cbi PORTB,7
nop
nop
nop
nop 
nop 
;nop
;nop
sbis PIND,2
ret
inc rea0
cpi rea0,200	
brne Mloop	
clr rea0
;
in tmp,pind	;Lautsprecher-Bit
neg tmp		;"alternieren" 
out PORTD,tmp	;(500Hz)
sbi portd,2     ;Pullup fuer Taste
;
inc rea1	;Tausendstel
cpi rea1,10	;Sekunden zhlen
brne Mloop
clr rea1
;
inc rea2	;Hundertstel
cpi rea2,10	;Sekunden
brne Mloop
clr rea2
;
inc rea3	;Zehntel
cpi rea3,10	;Sekunden
brne Mloop
;
Overflow:
ldi tmp,249	;"EE" anzeigen
out PORTB,tmp
rcall delay2
ldi tmp,121
out PORTB,tmp
rcall delay2
dec rea3 
brne Overflow	;paar Sek.warten
clr tmp
out PORTB,tmp
ser rea2
ser rea3
;
inc ovr
cpi ovr,3	;Anzahl Ueberlaeufe
breq Shutdown 	;bis zum Abschalten
ret 
;
; -------------------------------------
; Schlafmodus einleiten
; -------------------------------------
Shutdown:
ldi tmp,64	;Bit 6 fuer INT0 setzen 
out GIMSK,tmp   ;Interrupt Mask Register
ldi tmp,48	;INT0 erlauben in 
out MCUCR,tmp	;Controller-Register 
sei		;Interrupts zulassen
sleep		;Gute Nacht!
;
; -------------------------------------
; Laufzeitschleife 128 s (bei f=4MHz!)
; -------------------------------------
delay1:
clr cnt1
dly1: 
inc cnt1
brne dly1
ret
;
; -------------------------------------
; Laufzeitschleife ca. 1ms 
; -------------------------------------
ddelay:
rcall delay1
rcall delay1
rcall delay1
rcall delay1
rcall delay1
rcall delay1
rcall delay1
rcall delay1
ret
;
; -------------------------------------
; Laufzeitschleife 16 ms 
; -------------------------------------
delay2:
clr cnt2
dly2:
rcall delay1
dec cnt2
dec cnt2
brne dly2
ret
;
; -------------------------------------
; Laufzeitschleife 4 Sek. + Display aus 
; -------------------------------------  
ConstDelay:
clr tmp
out PORTB,tmp	;Display aus
clr cnt3
CnstDly:
rcall delay2
dec cnt3
brne CnstDly
ret
;
; -------------------------------------
; Display aus und Zufallspause 
; -------------------------------------
RandomDelay:
rcall delay2
dec rea0	
brne RandomDelay
ret
; --------------- ENDE ----------------

